#include <ArduinoJson.h>
#include "UbidotsESPMQTT.h"
#include<PubSubClient.h>
/****************************************
 * Define Constants
 ****************************************/
#define TOKEN "BBFF-wNckkPtNxW6vSW2ukXeG3U00y2wesv" // Your Ubidots TOKEN
#define WIFINAME "-----" //Your SSID
#define WIFIPASS "-----" // Your Wifi Pass

Ubidots client(TOKEN);

/****************************************
 * Auxiliar Functions
 ****************************************/

void callback(char* topic, byte* payload, unsigned int length) {
  Serial.print("Message arrived [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i=0;i<length;i++) {
    Serial.print((char)payload[i]);
  }
  Serial.println();
}

/****************************************
 * Main Functions
 ****************************************/

void setup() {
  // put your setup code here, to run once:
  //client.ubidotsSetBroker("industrial.api.ubidots.com"); // Sets the broker properly for the industrial account
  client.setDebug(true); // Pass a true or false bool value to activate debug messages
  Serial.begin(9600);
  client.wifiConnection(WIFINAME, WIFIPASS);
  client.begin(callback);
  }

void loop() {
  // put your main code here, to run repeatedly:
  if(!client.connected()){
      client.reconnect();
      }
  
  float temp = 0;
  float humi = 0;
  float pres = 0;
  String message = "";
  boolean messageReceived = false;

  // get JSON string from arduino
  DynamicJsonDocument doc(1024);
  while (messageReceived == false) {
    if (Serial.available()) {
      message = Serial.readString();
      messageReceived = true;
    }
  }

  deserializeJson(doc, message);
  temp = doc["temperature"];
  humi = doc["humidity"];
  pres = doc["pressure"];

  String output = "temperature: " + String(temp) + ", humidity: " + String(humi) + ", pressure: " + String(pres) + "\n";
  
  Serial.print(output);

  client.add("temperature", temp);
  client.ubidotsPublish("esp8266-test");

  client.add("humidity", humi);
  client.ubidotsPublish("esp8266-test");

  client.add("pressure", pres);
  client.ubidotsPublish("esp8266-test");

  delay(1000);
}
